Index: /trunk/SophyaPI/PI/Tests/midasitt.cc
===================================================================
--- /trunk/SophyaPI/PI/Tests/midasitt.cc	(revision 1932)
+++ /trunk/SophyaPI/PI/Tests/midasitt.cc	(revision 1933)
@@ -25,4 +25,5 @@
 
 #include "pisurfdr.h"
+#include "piyfxdrw.h"
 
 //  ---------- classe PITApp -----------------------
@@ -98,7 +99,7 @@
 PIColor col;  //  Les couleurs PI sont des entiers de 0 a 65535 (16 bits)
 for(int kc=0; kc<rgb_ncol; kc++) {
-  col.red = rgb_r[kc]*65535; 
-  col.green = rgb_g[kc]*65535; 
-  col.blue = rgb_b[kc]*65535; 
+  col.red   = (short unsigned)(rgb_r[kc]*65535); 
+  col.green = (short unsigned)(rgb_g[kc]*65535); 
+  col.blue  = (short unsigned)(rgb_b[kc]*65535); 
   midas_cmap.AllocColor(col, kc);
   }
@@ -186,6 +187,6 @@
 
       PIFuncDrawer* mfd = new PIFuncDrawer(fsinc);
-      mfd->SetColAtt(PI_Gold);
-      mfd->SetLineAtt(PI_NormalLine);
+      mfd->GetGraphicAtt().SetColAtt(PI_Gold);
+      mfd->GetGraphicAtt().SetLineAtt(PI_NormalLine);
       nbwin++; sprintf(strg,"2D Graphics (PI W %d)", nbwin);
       PIWindow* wp = new PIWindow(this, strg, PIWK_normal,  300, 300, 150, 150);
@@ -214,6 +215,6 @@
       PIYfXDrawer* mxyd = new   PIYfXDrawer( new P1DAdapter<float>(vpx, 30, true), 
                                             new P1DAdapter<float>(vpy, 30, true), true); 
-      mxyd->SetColAtt(PI_Red);
-      mxyd->SetMarkerAtt(7, PI_FTriangleMarker);
+      mxyd->GetGraphicAtt().SetColAtt(PI_Red);
+      mxyd->GetGraphicAtt().SetMarkerAtt(7, PI_FTriangleMarker);
 
       nbwin++; sprintf(strg,"2D Graphics (PI W %d)", nbwin);
@@ -241,10 +242,10 @@
                                              new P1DAdapter<float>(vpy, 30, true), true); 
 
-      mxyd->SetColAtt(PI_Magenta);
-      mxyd->SetMarkerAtt(7, PI_FBoxMarker);
+      mxyd->GetGraphicAtt().SetColAtt(PI_Magenta);
+      mxyd->GetGraphicAtt().SetMarkerAtt(7, PI_FBoxMarker);
 
       PIFuncDrawer* mfd = new PIFuncDrawer(fsinc);
-      mfd->SetColAtt(PI_Blue);
-      mfd->SetLineAtt(PI_NormalLine);
+      mfd->GetGraphicAtt().SetColAtt(PI_Blue);
+      mfd->GetGraphicAtt().SetLineAtt(PI_NormalLine);
 
       nbwin++; sprintf(strg,"2D Graphics (PI W %d)", nbwin);
@@ -404,7 +405,7 @@
       PIWindow* awp = new PIWindow(this, strg, PIWK_normal, 500, 500, 200, 200);
       PISurfaceDrawer* sd = new PISurfaceDrawer(new P2DAdapter<float>(tf, 50, 50, true), true, true, true);
-      if (fgswcol%3 == 0) sd->SetColMapId(CMAP_COLRJ32);
-      else if (fgswcol%3 == 1) sd->SetColMapId(CMAP_COLBR32);
-      else sd->SetColMapId(CMAP_COLRV32);
+      if (fgswcol%3 == 0) sd->GetGraphicAtt().SetColMapId(CMAP_COLRJ32);
+      else if (fgswcol%3 == 1) sd->GetGraphicAtt().SetColMapId(CMAP_COLBR32);
+      else sd->GetGraphicAtt().SetColMapId(CMAP_COLRV32);
       fgswcol++;
       PIDraw3DWdg* drw3 = new PIDraw3DWdg(awp, "ex3ddrw", 600, 600, 0, 0);
Index: /trunk/SophyaPI/PI/Tests/pit1.cc
===================================================================
--- /trunk/SophyaPI/PI/Tests/pit1.cc	(revision 1932)
+++ /trunk/SophyaPI/PI/Tests/pit1.cc	(revision 1933)
@@ -15,4 +15,5 @@
 #include "parradapter.h"
 
+#include "piyfxdrw.h"
 
 /*  Exemple d'utilisation PIBaseWdg - Creation d'une nouvelle composante graphique  */
@@ -261,6 +262,6 @@
 // Creation et ajout d'un drawer de fonctions
 PIFuncDrawer* mfd = new PIFuncDrawer(fpol);
-mfd->SetColAtt(PI_Blue);
-mfd->SetLineAtt(PI_NormalLine);
+mfd->GetGraphicAtt().SetColAtt(PI_Blue);
+mfd->GetGraphicAtt().SetLineAtt(PI_NormalLine);
 AddScDrawer(mfd,true);
 
@@ -268,10 +269,10 @@
 PIYfXDrawer* mxyd = new PIYfXDrawer(new P1DAdapter<float>(xpts, 10, false), 
                                     new P1DAdapter<float>(ypts, 10, false), true);
-mxyd->SetColAtt(PI_Magenta);
-mxyd->SetMarkerAtt(7, PI_FBoxMarker);
+mxyd->GetGraphicAtt().SetColAtt(PI_Magenta);
+mxyd->GetGraphicAtt().SetMarkerAtt(7, PI_FBoxMarker);
 AddScDrawer(mxyd, true);
 
 // Ajout de texte
-BaseDrawer()->SetFontAtt(PI_NormalSizeFont, PI_BoldFont);
+BaseDrawer()->GetGraphicAtt().SetFontAtt(PI_NormalSizeFont, PI_BoldFont);
 BaseDrawer()->ElAddText(-2.8, 12., "---- ScSample ----", PI_Red);
 BaseDrawer()->ElAddText(-2.8, 10.,  "f(x)=0.3*x^3-x^2+7.", PI_Red);
Index: /trunk/SophyaPI/PI/Tests/xp3.cc
===================================================================
--- /trunk/SophyaPI/PI/Tests/xp3.cc	(revision 1932)
+++ /trunk/SophyaPI/PI/Tests/xp3.cc	(revision 1933)
@@ -24,4 +24,5 @@
 
 #include "pisurfdr.h"
+#include "piyfxdrw.h"
 
 
@@ -144,11 +145,11 @@
                                   new P1DAdapter<float>(vpy, 30, true), true); 
     // Changing graphic attributes for the drawer
-    mxyd->SetColAtt(PI_Magenta);
-    mxyd->SetMarkerAtt(7, PI_FBoxMarker);
+    mxyd->GetGraphicAtt().SetColAtt(PI_Magenta);
+    mxyd->GetGraphicAtt().SetMarkerAtt(7, PI_FBoxMarker);
 
     // Using PIFuncDrawer and changing its attributes
     PIFuncDrawer* mfd = new PIFuncDrawer(fsinc);
-    mfd->SetColAtt(PI_Blue);
-    mfd->SetLineAtt(PI_NormalLine);
+    mfd->GetGraphicAtt().SetColAtt(PI_Blue);
+    mfd->GetGraphicAtt().SetLineAtt(PI_NormalLine);
 
     nbwin++; sprintf(strg,"2D Graphics (PI W %d)", nbwin);
@@ -178,7 +179,7 @@
                   new P2DAdapter<float>(tf, 50, 50, true), true, true, true);
     // Selecting color map
-    if (fgswcol%3 == 0) sd->SetColMapId(CMAP_COLRJ32);
-    else if (fgswcol%3 == 1) sd->SetColMapId(CMAP_COLBR32);
-    else sd->SetColMapId(CMAP_GREY32);
+    if (fgswcol%3 == 0) sd->GetGraphicAtt().SetColMapId(CMAP_COLRJ32);
+    else if (fgswcol%3 == 1) sd->GetGraphicAtt().SetColMapId(CMAP_COLBR32);
+    else sd->GetGraphicAtt().SetColMapId(CMAP_GREY32);
     fgswcol++;
     // Creating a 3D Widget (managing 3D-Drawers, rotation , ... )